package fr.insa.clavardator;

import fr.insa.clavardator.network.NetDiscoverer;
import fr.insa.clavardator.ui.MainController;
import fr.insa.clavardator.util.ErrorHandler;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

// See here : https://github.com/jfoenixadmin/JFoenix/blob/master/demo/src/main/java/demos/components/DrawerDemo.java

public class MainApp extends Application {

	public static void main(String[] args) {
		launch(args);
	}

	@Override
	public void start(Stage stage) throws Exception {
//		String javaVersion = System.getProperty("java.version");
//		String javafxVersion = System.getProperty("javafx.version");

		final FXMLLoader mainLoader = new FXMLLoader(getClass().getResource("ui/scene.fxml"));
		final MainController main = mainLoader.getController();
		final Parent content = mainLoader.load();

		Scene scene = new Scene(content);

		stage.setScene(scene);
		stage.setTitle("Clavardator");
		stage.setMinHeight(640);
		stage.setMinWidth(800);
		stage.setMaximized(true);
		stage.show();

		// Network discovery test
		ErrorHandler.getInstance().addObserver(evt -> ((Exception)evt.getNewValue()).printStackTrace());

		NetDiscoverer.discoverActiveUsers("Broadcast",
				(ipAddr, data) -> System.out.println("User detected at address : " + ipAddr.toString())
		);
		NetDiscoverer.startDiscoveryListening("Yohan", null);
	}

	@Override
	public void stop() throws Exception {
		NetDiscoverer.stopDiscovery();
		super.stop();
	}
}