package fr.insa.clavardator.chat;

import fr.insa.clavardator.users.CurrentUser;
import fr.insa.clavardator.users.User;

import java.io.Serializable;

public class Message implements Serializable {
	private String text;
	private final User recipient;
	private final User sender;

	public Message(User sender, User recipient) {
		this(sender, recipient, "");
	}

	public Message(User sender, User recipient, String text) {
		this.sender = sender;
		this.recipient = recipient;
		this.text = text;
	}

	public String getText() {
		return text;
	}

	public User getSender() {
		return sender;
	}
}
