package fr.insa.clavardator.ui;

import fr.insa.clavardator.ui.chat.ChatController;
import fr.insa.clavardator.ui.users.UserListController;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;

import java.net.URL;
import java.util.ResourceBundle;

public class MainController implements Initializable {

	@FXML
	private UserListController userListController;
	@FXML
	private ChatController chatController;

	@Override
	public void initialize(URL url, ResourceBundle rb) {
		userListController.addRefreshUserListener(() -> {
			System.out.println("refresh event");
		});
		userListController.addUserSelectedListener((user) -> {
			System.out.println(user.getUsername());
		});
		chatController.addAttachmentListener(() -> {
			System.out.println("attach event");
		});
		chatController.addSendListener(() -> {
			System.out.println("send event");
		});
		chatController.addEditListener(() -> {
			System.out.println("edit event");
		});
	}
}
