package fr.insa.clavardator.ui.chat;

import fr.insa.clavardator.ui.ButtonPressEvent;
import javafx.fxml.Initializable;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

public class ChatFooterController implements Initializable {

	private List<ButtonPressEvent> attachmentListeners;
	private List<ButtonPressEvent> sendListeners;

	public void addAttachmentListener(ButtonPressEvent listener) {
		attachmentListeners.add(listener);
	}
	public void addSendListener(ButtonPressEvent listener) {
		sendListeners.add(listener);
	}

	public void onAttachmentPress() {
		attachmentListeners.forEach(ButtonPressEvent::onPress);
	}
	public void onSendPress() {
		sendListeners.forEach(ButtonPressEvent::onPress);
	}

	@Override
	public void initialize(URL location, ResourceBundle resources) {
		attachmentListeners = new ArrayList<>();
		sendListeners = new ArrayList<>();
	}
}
