package fr.insa.clavardator.ui.chat;

import fr.insa.clavardator.chat.Message;
import fr.insa.clavardator.users.CurrentUser;
import fr.insa.clavardator.users.User;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.ListCell;

import java.io.IOException;

public class MessageListItemCell extends ListCell<Message> {

	public MessageListItemCell() {
		setStyle("-fx-padding: 0px");
	}

	@Override
	protected void updateItem(Message item, boolean empty) {
		super.updateItem(item, empty);
		if (item != null) {
			FXMLLoader cellLoader;
			final User sender = item.getSender();
			if (sender instanceof CurrentUser) {
				cellLoader = new FXMLLoader(getClass().getResource("messageListItemSelf.fxml"));
			} else {
				cellLoader = new FXMLLoader(getClass().getResource("messageListItemOther.fxml"));
			}
			try {
				setGraphic(cellLoader.load());
				final MessageListItemController userListItemController = cellLoader.getController();
				userListItemController.setMessage(item.getText());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}