package fr.insa.clavardator.ui.users;

import fr.insa.clavardator.ui.UserSelectedEvent;
import fr.insa.clavardator.users.User;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.ListCell;

import java.io.IOException;

public class UserListItemCell extends ListCell<User> {

	private UserSelectedEvent listener;

	public UserListItemCell() {
		setStyle("-fx-padding: 0px");
	}

	public void setOnUserSelectedListener(UserSelectedEvent listener) {
		this.listener = listener;
	}

	@Override
	protected void updateItem(User item, boolean empty) {
		super.updateItem(item, empty);
		if (!empty && item != null) {
			final FXMLLoader cellLoader = new FXMLLoader(getClass().getResource("userListItem.fxml"));
			try {
				setGraphic(cellLoader.load());
				UserListItemController userListItemController = cellLoader.getController();
				userListItemController.setUser(item);
				userListItemController.setOnPressListener(() -> {
					if (listener != null) {
						listener.onSelected(item);
					}
				});
				userListItemController.setSelected(isSelected());
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			setGraphic(null);
		}
	}
}
