package fr.insa.clavardator.users;

import org.jetbrains.annotations.NotNull;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;

public class User implements Serializable, Comparable<User> {
	protected String username;

	// Make this class observable
	protected final transient PropertyChangeSupport pcs = new PropertyChangeSupport(this);
	public void addObserver(PropertyChangeListener listener) {
		pcs.addPropertyChangeListener(listener);
	}
	public void removeObserver(PropertyChangeListener listener) {
		pcs.removePropertyChangeListener(listener);
	}

	public User(String username) {
		this.username = username;
	}

	/**
	 * @return the current value of username
	 */
	public String getUsername() {
		return username;
	}


	@Override
	public int compareTo(@NotNull User o) {
		if ((o instanceof ActiveUser) && !(this instanceof ActiveUser)) {
			return 1;
		} else if (!(o instanceof ActiveUser) && (this instanceof ActiveUser)) {
			return -1;
		}
		return username.compareTo(o.username);
	}
}
