package fr.insa.clavardator.users;

import fr.insa.clavardator.db.DatabaseController;
import fr.insa.clavardator.network.NetDiscoverer;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.ArrayList;
import java.util.function.Predicate;

public class UserList {

	private ArrayList<ActiveUser> activeUsers;
	private ArrayList<PeerUser> inactiveUsers;
	private final DatabaseController db = new DatabaseController();

	// Make this class observable
	private final PropertyChangeSupport pcs = new PropertyChangeSupport(this);
	public void addObserver(PropertyChangeListener listener) {
		pcs.addPropertyChangeListener(listener);
	}
	public void removeObserver(PropertyChangeListener listener) {
		pcs.removePropertyChangeListener(listener);
	}

	public UserList() {
	}

	/**
	 * @param username
	 * @return boolean
	 */
	public boolean isUsernameAvailable(String username) {
		Predicate<User> usernameEqual = user -> user.username.equals(username);
		return activeUsers.stream().noneMatch(usernameEqual) &&
				inactiveUsers.stream().noneMatch(usernameEqual);
	}


	/**
	 * @param username
	 */
	public void propagateUsernameChange(String username) {
	}


	/**
	 *
	 */
	public void discoverActiveUsers() {
		NetDiscoverer.discoverActiveUsers("CLAVARDATOR_BROADCAST", (ipAddr, data) -> {
			ActiveUser newUser = new ActiveUser("", ipAddr); // TODO find username
			activeUsers.add(newUser);
			pcs.firePropertyChange("activeUsers", null, newUser);
		});
	}

}
