package fr.insa.clavardator.util;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

public class ErrorHandler {
	private ErrorHandler() {}

	// Make this class observable
	private final PropertyChangeSupport pcs = new PropertyChangeSupport(this);
	public void addObserver(PropertyChangeListener listener) { pcs.addPropertyChangeListener(listener); }
	public void removeObserver(PropertyChangeListener listener) { pcs.removePropertyChangeListener(listener); }

	private static ErrorHandler instance;

	public static ErrorHandler getInstance() {
		if (instance == null)
			instance = new ErrorHandler();
		return instance;
	}


	public void notifyError(Exception exception) {
		pcs.firePropertyChange("exception", null, exception);
	}
}
